/*
 * $Id: ConcreteInterfaceFactory.java,v 1.4 2005/05/31 14:38:19 rampil Exp $
 * Copyright (c) 2004 LOGICAL-PARADOX.ORG
 */
package org.logical_paradox.koike.core;

import java.util.Iterator;

import org.logical_paradox.koike.core.document.DocumentAccessor;
import org.logical_paradox.koike.core.indexer.IndexAccessor;
import org.logical_paradox.koike.core.search.SearchConditionOptimizer;

/**
 * ۃC^[tF[Xt@Ng
 * ݒt@CɂāCeC^[tF[X̋ۃNX̉ĕԂ܂D
 * 
 * @author satoshi akabane@logical-paradox.org
 * @version $Revision: 1.4 $
 */
public abstract class ConcreteInterfaceFactory {
	private String initparam;
	/**
	 * RXgN^
	 * @param param p[^
	 * @throws Exception O
	 */
	public ConcreteInterfaceFactory(String param) throws Exception {
		initparam = param;
		setup();
	}
	/**
	 * p[^Ԃ
	 * @return p[^
	 */
	protected String getInitparam() {
		return initparam;
	}
	/**
	 * t@Ng܂
	 * @throws Exception 
	 */
	public abstract void setup() throws Exception;
	/**
	 * ꂽhLgANZT𐶐ĕԂ
	 * @return ꂽhLgANZT
	 * @throws Exception ܂͏ɎsꍇɔO
	 */
	public abstract DocumentAccessor getDocumentAccessor() throws Exception;
	/**
	 * ꂽCfbNXANZT𐶐ĕԂ
	 * @return ꂽCfbNXANZT
	 * @throws Exception ܂͏ɎsꍇɔO
	 */
	public abstract IndexAccessor getIndexAccessor() throws Exception;
	/**
	 * [gL[ɃV[PVɃANZX@𐶐ĕԂ
	 */
	public abstract Iterator getRemoteQueueIterator() throws Exception;
	/**
	 * IveB}CU[𐶐ĕԂ
	 * @return IveB}CU[
	 * @throws Exception ɔO
	 */
	public abstract SearchConditionOptimizer getOptimizer() throws Exception;
}
